-- Globals --
if not QuickCD then
    QuickCD = {}
end
QuickCD.CfgUI = {}

-- Locals --
local alertStruct = {
                        abilityName = '',
                        disabled = false,
                        x = 10,
                        y = 10,
                        textSize = 20,
                        colorR = 0,
                        colorG = 0,
                        colorB = 0,
                    }

-- Methods --
function QuickCD.CfgUI.Init() -- Build the UI
    -- Main Frame
    QuickCD.CfgUI.mainFrame = UI.CreateFrame("SimpleWindow", "", QuickCD.context)
    QuickCD.CfgUI.mainFrame:SetVisible(false)
    QuickCD.CfgUI.mainFrame:SetLayer(1)
    QuickCD.CfgUI.mainFrame:SetCloseButtonVisible(true)
    QuickCD.CfgUI.mainFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 300, 300)
    QuickCD.CfgUI.mainFrame:SetWidth(800)
    QuickCD.CfgUI.mainFrame:SetHeight(600)
    
    
    -- Left buttons/list scroller
    QuickCD.CfgUI.addButton = UI.CreateFrame("RiftButton", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.addButton:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 17, 55)
    QuickCD.CfgUI.addButton:SetText("New")
    QuickCD.CfgUI.addButton:SetWidth(120)
    QuickCD.CfgUI.addButton:SetLayer(10)
    
    QuickCD.CfgUI.deleteButton = UI.CreateFrame("RiftButton", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.deleteButton:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 137, 55)
    QuickCD.CfgUI.deleteButton:SetText("Delete")
    QuickCD.CfgUI.deleteButton:SetWidth(120)
    QuickCD.CfgUI.deleteButton:SetLayer(10)
    
    QuickCD.CfgUI.leftScroller = UI.CreateFrame("SimpleScrollView", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.leftScroller:SetLayer(10)
    QuickCD.CfgUI.leftScroller:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 14, 90)
    QuickCD.CfgUI.leftScroller:SetShowScrollbar(true)
    QuickCD.CfgUI.leftScroller:SetHeight(497)
    QuickCD.CfgUI.leftScroller:SetWidth(250)
    QuickCD.CfgUI.leftScroller:SetScrollbarWidth(20)
    
    QuickCD.CfgUI.leftList = UI.CreateFrame("SimpleList", "", QuickCD.CfgUI.leftScroller)
    QuickCD.CfgUI.leftList:SetLayer(10)
    QuickCD.CfgUI.leftList:SetFontSize(16)
    QuickCD.CfgUI.leftList:SetLevelFontColor(1, 1, 1, 1)
    QuickCD.CfgUI.leftList:SetSelectionBackgroundColor(0, 0.55, 0, 1)
    QuickCD.CfgUI.leftList:SetLevelSelectable(1, true)
    
    QuickCD.CfgUI.RefreshAlerts()
    
    QuickCD.CfgUI.leftScroller:SetContent(QuickCD.CfgUI.leftList)
    
    -- Right alert-specific settings
    -- Row 1
    QuickCD.CfgUI.abilityNameText = UI.CreateFrame("Text", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.abilityNameText:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 280, 77)
    QuickCD.CfgUI.abilityNameText:SetText("Ability Name:")
    QuickCD.CfgUI.abilityNameText:SetFontColor(1, 1, 1)
    QuickCD.CfgUI.abilityNameText:SetFontSize(16)
    QuickCD.CfgUI.abilityNameText:SetLayer(10)
    
    QuickCD.CfgUI.abilityNameTextField = UI.CreateFrame("RiftTextfield", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.abilityNameTextField:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 382, 77)
    QuickCD.CfgUI.abilityNameTextField:SetBackgroundColor(0, 0, 0, 0.7)
    QuickCD.CfgUI.abilityNameTextField:SetWidth(337)
    QuickCD.CfgUI.abilityNameTextField:SetText("")
    QuickCD.CfgUI.abilityNameTextField:SetLayer(10)
    
    -- Row 2
    QuickCD.CfgUI.sizeText = UI.CreateFrame("Text", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.sizeText:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 280, 150)
    QuickCD.CfgUI.sizeText:SetText("Text Size:")
    QuickCD.CfgUI.sizeText:SetFontColor(1, 1, 1)
    QuickCD.CfgUI.sizeText:SetFontSize(16)
    QuickCD.CfgUI.sizeText:SetLayer(10)
    
    QuickCD.CfgUI.sizeDropdown = UI.CreateFrame("SimpleSelect", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.sizeDropdown:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 351, 150)
    QuickCD.CfgUI.sizeDropdown:SetBackgroundColor(0, 0, 0, 0.7)
    local sizeOptions = { '8', '10', '12', '14', '16', '18', '20', '22', '24', '26', '28', '30', '32', '34', '36', '38', '40', '50', '60', '70'}
    QuickCD.CfgUI.sizeDropdown:SetItems(sizeOptions)
    QuickCD.CfgUI.sizeDropdown:SetSelectedItem('20', true)
    QuickCD.CfgUI.sizeDropdown:SetFontSize(16)
    QuickCD.CfgUI.sizeDropdown:ResizeToFit()
    QuickCD.CfgUI.sizeDropdown:SetWidth(50)
    QuickCD.CfgUI.sizeDropdown:SetLayer(20) -- SimpleSelect = higher layer
    
    QuickCD.CfgUI.colorText = UI.CreateFrame("Text", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.colorText:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 439, 150)
    QuickCD.CfgUI.colorText:SetText("Text Color:")
    QuickCD.CfgUI.colorText:SetFontColor(1, 1, 1)
    QuickCD.CfgUI.colorText:SetFontSize(16)
    QuickCD.CfgUI.colorText:SetLayer(10)
    
    QuickCD.CfgUI.colorDropdown = UI.CreateFrame("SimpleSelect", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.colorDropdown:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 523, 150)
    QuickCD.CfgUI.colorDropdown:SetBackgroundColor(0, 0, 0, 0.7)
    local colorOptions = { 'black', 'white', 'gray', 'red', 'green', 'blue', 'purple', 'teal', 'dark red', 'dark green', 'dark blue'}
    local colorValues = { "0,0,0", "1,1,1", "0.5,0.5,0.5", "1,0,0", "0,1,0", "0,0,1", "1,0,1", "0,1,1", "0.5,0,0", "0,0.5,0", "0,0,0.5" }
    QuickCD.CfgUI.colorDropdown:SetItems(colorOptions, colorValues)
    QuickCD.CfgUI.colorDropdown:SetSelectedItem('black', true)
    QuickCD.CfgUI.colorDropdown:SetFontSize(16)
    QuickCD.CfgUI.colorDropdown:ResizeToFit()
    QuickCD.CfgUI.colorDropdown:SetLayer(20) -- SimpleSelect = higher layer
    
    QuickCD.CfgUI.disabledCheckbox = UI.CreateFrame("SimpleCheckbox", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.disabledCheckbox:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 638, 150)
    QuickCD.CfgUI.disabledCheckbox:SetText("Disabled:")
    QuickCD.CfgUI.disabledCheckbox:SetFontSize(16)
    QuickCD.CfgUI.disabledCheckbox:SetLabelPos("left")
    QuickCD.CfgUI.disabledCheckbox:ResizeToFit()
    QuickCD.CfgUI.disabledCheckbox:SetLayer(10)
    
    -- Row 3
    QuickCD.CfgUI.xText = UI.CreateFrame("Text", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.xText:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 280, 210)
    QuickCD.CfgUI.xText:SetText("X:")
    QuickCD.CfgUI.xText:SetFontColor(1, 1, 1)
    QuickCD.CfgUI.xText:SetFontSize(16)
    QuickCD.CfgUI.xText:SetLayer(10)
    
    QuickCD.CfgUI.xTextField = UI.CreateFrame("RiftTextfield", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.xTextField:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 301, 210)
    QuickCD.CfgUI.xTextField:SetBackgroundColor(0, 0, 0, 0.7)
    QuickCD.CfgUI.xTextField:SetWidth(60)
    QuickCD.CfgUI.xTextField:SetText("10")
    QuickCD.CfgUI.xTextField:SetLayer(10)
    
    QuickCD.CfgUI.yText = UI.CreateFrame("Text", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.yText:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 400, 210)
    QuickCD.CfgUI.yText:SetText("Y:")
    QuickCD.CfgUI.yText:SetFontColor(1, 1, 1)
    QuickCD.CfgUI.yText:SetFontSize(16)
    QuickCD.CfgUI.yText:SetLayer(10)
    
    QuickCD.CfgUI.yTextField = UI.CreateFrame("RiftTextfield", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.yTextField:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 418, 210)
    QuickCD.CfgUI.yTextField:SetBackgroundColor(0, 0, 0, 0.7)
    QuickCD.CfgUI.yTextField:SetWidth(60)
    QuickCD.CfgUI.yTextField:SetText("10")
    QuickCD.CfgUI.yTextField:SetLayer(10)
    
    QuickCD.CfgUI.moveButton = UI.CreateFrame("RiftButton", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.moveButton:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 516, 205)
    QuickCD.CfgUI.moveButton:SetText("Move")
    QuickCD.CfgUI.moveButton:SetLayer(10)
    
    -- Row 4
    QuickCD.CfgUI.saveButton = UI.CreateFrame("RiftButton", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.saveButton:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 608, 250)
    QuickCD.CfgUI.saveButton:SetText("Save Alert")
    QuickCD.CfgUI.saveButton:SetLayer(10)
    
    -- Row 5
    QuickCD.CfgUI.seperator = UI.CreateFrame("Text", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.seperator:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 280, 300)
    QuickCD.CfgUI.seperator:SetText("------------------------------------------------------")
    QuickCD.CfgUI.seperator:SetFontColor(1, 1, 1)
    QuickCD.CfgUI.seperator:SetFontSize(24)
    QuickCD.CfgUI.seperator:SetLayer(10)
    
    -- Row 6
    QuickCD.CfgUI.globalText = UI.CreateFrame("Text", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.globalText:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 465, 320)
    QuickCD.CfgUI.globalText:SetText("Global Settings")
    QuickCD.CfgUI.globalText:SetFontColor(1, 1, 1)
    QuickCD.CfgUI.globalText:SetFontSize(17)
    QuickCD.CfgUI.globalText:SetLayer(10)
    
    -- Row 7
    QuickCD.CfgUI.GCDText = UI.CreateFrame("Text", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.GCDText:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 280, 375)
    QuickCD.CfgUI.GCDText:SetText("Your Global Cooldown Time:")
    QuickCD.CfgUI.GCDText:SetFontColor(1, 1, 1)
    QuickCD.CfgUI.GCDText:SetFontSize(16)
    QuickCD.CfgUI.GCDText:SetLayer(10)
    
    QuickCD.CfgUI.GCDDropdown = UI.CreateFrame("SimpleSelect", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.GCDDropdown:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 490, 375)
    QuickCD.CfgUI.GCDDropdown:SetBackgroundColor(0, 0, 0, 0.7)
    local GCDOptions = { '1.0', '1.5' }
    QuickCD.CfgUI.GCDDropdown:SetItems(GCDOptions)
    local GCD = string.format("%.1f", QuickCD_Config['GCD'])
    QuickCD.CfgUI.GCDDropdown:SetSelectedItem(GCD, true)
    QuickCD.CfgUI.GCDDropdown:SetFontSize(16)
    QuickCD.CfgUI.GCDDropdown:ResizeToFit()
    QuickCD.CfgUI.GCDDropdown:SetWidth(50)
    QuickCD.CfgUI.GCDDropdown:SetLayer(19) -- SimpleSelect = higher layer
    
    -- Row 8
    QuickCD.CfgUI.onCheckbox = UI.CreateFrame("SimpleCheckbox", "", QuickCD.CfgUI.mainFrame)
    QuickCD.CfgUI.onCheckbox:SetPoint("TOPLEFT", QuickCD.CfgUI.mainFrame, "TOPLEFT", 280, 420)
    QuickCD.CfgUI.onCheckbox:SetText("Quick Cooldowns Enabled:")
    QuickCD.CfgUI.onCheckbox:SetFontSize(16)
    QuickCD.CfgUI.onCheckbox:SetLabelPos("left")
    QuickCD.CfgUI.onCheckbox:ResizeToFit()
    QuickCD.CfgUI.onCheckbox:SetChecked(QuickCD_Config['on'])
    QuickCD.CfgUI.onCheckbox:SetLayer(10)
    
    function QuickCD.CfgUI.mainFrame.Event:Close() -- Make sure nothing has focus, so we don't get bugged when closing the window
        QuickCD.CfgUI.mainFrame:SetKeyFocus(true)
        QuickCD.CfgUI.mainFrame:SetKeyFocus(false)
        QuickCD.CfgUI.mainFrame:SetVisible(false)
    end
    
    function QuickCD.CfgUI.leftList.Event:ItemSelect(item, value, index)
        if not item and not value and not index then
            return
        end
        QuickCD.CfgUI.UpdateValues(index)
    end
    
    function QuickCD.CfgUI.GCDDropdown.Event:ItemSelect(item, value, index)
        if not item and not value and not index then
            return
        end
        QuickCD.CfgUI.UpdateGCD(item)
    end
   
    function QuickCD.CfgUI.addButton.Event:LeftClick()
        QuickCD.CfgUI.AddNewAlert()
        QuickCD.CfgUI.RefreshAlerts()
        QuickCD.CfgUI.leftList:SetSelectedIndex(#QuickCD_Config['alerts'][QuickCD.currRole]) -- Select the newest one, the one that we just added
    end
    
    function QuickCD.CfgUI.deleteButton.Event:LeftClick()
        QuickCD.CfgUI.DeleteCurrentAlert()
    end
    
    function QuickCD.CfgUI.moveButton.Event:LeftClick()
        local id = QuickCD.CfgUI.leftList:GetSelectedIndex()
        if id == nil then
            return
        end
        if not QuickCD.AlertUI.framesMoving[id] then
            QuickCD.AlertUI.Update(id, true)
        else
            QuickCD.AlertUI.SavePosition(id)
        end
    end
    
    function QuickCD.CfgUI.saveButton.Event:LeftClick()
        local id = QuickCD.CfgUI.leftList:GetSelectedIndex()
        if id == nil then
            return
        end
        if QuickCD.AlertUI.framesMoving[id] then
            QuickCD.AlertUI.SavePosition(id)
        end
        QuickCD.CfgUI.SaveCurrentAlert()
    end
    
    function QuickCD.CfgUI.onCheckbox.Event:CheckboxChange()
        QuickCD_Config['on'] = QuickCD.CfgUI.onCheckbox:GetChecked()
    end
    QuickCD.CfgUI.leftList:SetSelectedIndex(1)
end

function QuickCD.CfgUI.RefreshAlerts(selectedId) -- Refreshes all alerts in list
    if selectedId == nil then
        selectedId = QuickCD.CfgUI.leftList:GetSelectedIndex()
    end
    local items = {}
    local values = {}
    local levels = {}
    for key, value in pairs(QuickCD_Config['alerts'][QuickCD.currRole]) do
        local name = value['abilityName']
        if name == "" then
            name = "[Empty]"
        end
        table.insert(items, name)
        table.insert(values, nil)
        table.insert(levels, 1)
    end
    QuickCD.CfgUI.leftList:SetItems(items, values, levels)
    QuickCD.CfgUI.leftList:SetSelectedIndex(selectedId)
end

function QuickCD.CfgUI.DeleteCurrentAlert() -- Delete's currently selected alert
    local id = QuickCD.CfgUI.leftList:GetSelectedIndex()
    if id == nil then
        return
    end
    QuickCD.AlertUI.Remove(id, true)
    table.remove(QuickCD_Config['alerts'][QuickCD.currRole], id)
    QuickCD.CfgUI.RefreshAlerts(1)
end

function QuickCD.CfgUI.SaveCurrentAlert() -- Saves UI configs to alert
    local id = QuickCD.CfgUI.leftList:GetSelectedIndex()
    if id == nil then
        return
    end
    local abilityName = QuickCD.CfgUI.abilityNameTextField:GetText()
    local disabled = QuickCD.CfgUI.disabledCheckbox:GetChecked()
    local x = QuickCD.CfgUI.xTextField:GetText()
    local y = QuickCD.CfgUI.yTextField:GetText()
    local textSize = QuickCD.CfgUI.sizeDropdown:GetSelectedItem()
    local colors = QuickCD.Utils.StrSplit(",", QuickCD.CfgUI.colorDropdown:GetSelectedValue())
    local colorR = colors[1]
    local colorG = colors[2]
    local colorB = colors[3]
    QuickCD.CfgUI.UpdateAlert(id, abilityName, disabled, x, y, textSize, colorR, colorG, colorB)
    QuickCD.CfgUI.RefreshAlerts()
end

function QuickCD.CfgUI.UpdateValues(id) -- Updates UI fields based on alert
    if id == nil then
        id = QuickCD.CfgUI.leftList.GetSelectedItem()
    end
    local alert = QuickCD_Config['alerts'][QuickCD.currRole][id]
    if not alert then
        print("Error 1! Can't load alert.")
    end
    QuickCD.AlertUI.ClearAllMoving()
    QuickCD.CfgUI.abilityNameTextField:SetText(alert['abilityName'])
    QuickCD.CfgUI.disabledCheckbox:SetChecked(alert['disabled'])
    local x = string.format("%.0f", alert['x'])
    local y = string.format("%.0f", alert['y'])
    QuickCD.CfgUI.xTextField:SetText(x)
    QuickCD.CfgUI.yTextField:SetText(y)
    QuickCD.CfgUI.sizeDropdown:SetSelectedItem(string.format("%.0f", alert['textSize']))
    local color = alert['colorR'] .. "," .. alert['colorG'] .. "," .. alert['colorB']
    QuickCD.CfgUI.colorDropdown:SetSelectedValue(color)
end

function QuickCD.CfgUI.UpdateGCD(newGCD) -- Updates GCD setting
    local GCD = tonumber(newGCD)
    if GCD ~= nil then
        QuickCD_Config['GCD'] = GCD
    end
end

function QuickCD.CfgUI.AddNewAlert() -- Adds new alert to configs
    local id = #QuickCD_Config['alerts'][QuickCD.currRole] + 1
    QuickCD_Config['alerts'][QuickCD.currRole][id] = QuickCD.Utils.DeepCopy(alertStruct)
end

function QuickCD.CfgUI.UpdateAlert(id, __abilityName, __disabled, __x, __y, __textSize, __colorR, __colorG, __colorB) -- Updates alert in configs
    if not QuickCD_Config['alerts'][QuickCD.currRole][id] then
        return false
    end
    
    -- Set up all the input to update the alert
    local _abilityName = __abilityName
    local _disabled = __disabled
    local _x = tonumber(__x)
    local _y = tonumber(__y)
    
    local function chkNum(value, _min, _max)
       local _value = tonumber(value)
       if _value ~= nil then
           if not (_value >= _min and _value <= _max) then
               _value = nil
           end
       end
       return _value
    end
    local _textSize = chkNum(__textSize, 8, 70)
    local _colorR = chkNum(__colorR, 0, 1)
    local _colorG = chkNum(__colorG, 0, 1)
    local _colorB = chkNum(__colorB, 0, 1)
    
    if _abilityName ~= nil then
        QuickCD_Config['alerts'][QuickCD.currRole][id]['abilityName'] = _abilityName
    end
    if _disabled ~= nil then
        QuickCD_Config['alerts'][QuickCD.currRole][id]['disabled'] = _disabled
    end
    if _x ~= nil then
        QuickCD_Config['alerts'][QuickCD.currRole][id]['x'] = _x
    end
    if _y ~= nil then
        QuickCD_Config['alerts'][QuickCD.currRole][id]['y'] = _y
    end
    if _textSize ~= nil then
        QuickCD_Config['alerts'][QuickCD.currRole][id]['textSize'] = _textSize
    end
    if _colorR ~= nil then
        QuickCD_Config['alerts'][QuickCD.currRole][id]['colorR'] = _colorR
    end
    if _colorG ~= nil then
        QuickCD_Config['alerts'][QuickCD.currRole][id]['colorG'] = _colorG
    end
    if _colorB ~= nil then
        QuickCD_Config['alerts'][QuickCD.currRole][id]['colorB'] = _colorB
    end
    
    QuickCD.AlertUI.Update(id)
end